# OneRoster CSV出力

JapanProfile_v.1.2に準拠したCSV出力を行います。

## 実装方法

当対応ではRDBMSにSQLServerを利用しています。
ストアドプロシージャによりCSV出力情報を中間テーブルに作成し、クエリ実行によりCSVファイルを書き出します。
CSVの書き出しにはsqlcmdを利用します。

## 前提条件

- 各モデルに該当する中間テーブルが事前に作成されていること
    - users
    - academicSessions
    - classes
    - courses
    - enrollments
    - orgs
    - roles
- CSV出力クエリ実行時に必要となるユーザ定義関数が作成されていること。

## サンプルコードの提供内容

### 提供対象

- 各モデルに該当する中間テーブル作成用DDL
`01.DDL.sql`が該当
※処理の都合上、JapanProfile v1.2に定義されていない項目列が含まれます。
- CSV出力時におけるダブルクォーテーション付与に用いるユーザ定義関数
`02.create_udf.sql`が該当
- 各中間テーブルへのレコード投入用ストアドプロシージャ
`03.sp_create_oneroster_csv.sql`が該当
これを`04.execute_sp.sql`で実行
- CSV出力用クエリとバッチファイル
`_output.bat`を実行し、同階層の`query`フォルダ配下のクエリをsqlcmdで実行しCSV出力を行う。

### 非提供対象

以下の内容は当社システム独自の内容を多く含むため提供範囲外とします。

- 各中間テーブルにレコードを投入するストアドプロシージャ内で実行されるクエリ

## その他留意事項

- sqlcmd実行で出力されたCSVファイルはエンコーディングがSJISとなります。
UTF-8へのエンコーディング変換は別途ツールで実施しています。
