module OmniAuth
  module Strategies
    class StudentLti < OmniAuth::Strategies::OpenIDConnect
      # ГƎ̈悱---
      ## "state"Cookieɕۑ
      def new_state
        v = super
        response.set_cookie 'omniauth.state', { domain: cookie_domain, value: v, same_site: 'None', secure: true }
        v
      end

      ## session܂CookieۑĂ"state"擾A
      ## wZFQDN(redirect_uriȊOFQDN)ŃANZXĂĂꍇ͕ۑĂ"state"폜
      def stored_state
        domain = @env["SERVER_NAME"]
        if domain == redirect_uri_domain
          session['omniauth.state']
        else
          v = super
          v ||= request.cookies['omniauth.state']
          response.delete_cookie 'omniauth.state'
          v
        end
      end

      ## "nonce"Cookieɕۑ
      def new_nonce
        v = super
        response.set_cookie 'omniauth.nonce', { domain: cookie_domain, value: v, same_site: 'None', secure: true }
        v
      end

      ## session܂CookieۑĂ"nonce"擾A
      ## wZFQDN(redirect_uriȊOFQDN)ŃANZXĂĂꍇ͕ۑĂ"nonce"폜
      def stored_nonce
        domain = @env["SERVER_NAME"]
        if domain == redirect_uri_domain
          session['omniauth.nonce']
        else
          v = super
          v ||= request.cookies['omniauth.nonce']
          response.delete_cookie 'omniauth.nonce'
          v
        end
      end

      ## Rack::ResponseIuWFNg擾
      def response
        @response ||= Rack::Response.new
      end

      ## _CNg
      def redirect(uri)
        if options[:iframe]
          response.write("<script type='text/javascript' charset='utf-8'>top.location.href = '#{uri}';</script>")
        else
          response.write("Redirecting to #{uri}...")
          response.redirect(uri)
        end

        response.finish
      end

      ## redirect_uriFQDN擾
      def redirect_uri_domain
        URI.parse(client_options.redirect_uri).host
      end

      ## cookiedomainɎw肷l擾
      def cookie_domain
        Rails.application.config.app_name[:student_domain]
      end
      # ГƎ̈悱܂---
    end
  end
end
