import lombok.extern.slf4j.Slf4j;

/**
 * <pre>
 * 文字列操作に関するユーティリティ(抜粋)
 * </pre>
 *
 */

/**
 * *****************************************************************************
 * 文字列操作に関するユーティリティ
 * <pre>
 * [機能説明]
 * 1.文字列に関する処理を記述する
 * [注意事項]
 * (なし)
 * </pre>
 * ****************************************************************************
 *
 */
@Slf4j
public class StringUtility {

  /*****************************************************************************
   * インスタンスを生成する
   * <pre>
   *   [機能説明]
   *    1.インスタンス化を抑止するためにprivateで宣言する。
   *   [注意事項]
   *    (なし)
   * </pre>
   ****************************************************************************/
  private StringUtility() {
  }


  /**
   * ***************************************************************************
   * 文字列空判定
   * <pre>
   * [機能説明]
   * 1.文字列がnullまたは空文字(スペースのみも空文字と判定)を判定
   * [注意事項]
   * (なし)
   * </pre>
   *
   * @param str 文字列
   * @return 文字列が空のときはtrue、そうでないときはfalse **************************************************************************
   */
  public static boolean isBlankOrNull(String str) {
    return str == null || str.trim().length() == 0;
  }

  /**
   * *************************************************************************** 文字列イコール判定
   * <pre>
   * [機能説明]
   * 1.二つの文字列が同じかどうかを判定する
   * 2.nullとnullを渡されたときは同値と判定する
   * [注意事項]
   * (なし)
   * </pre>
   *
   * @param str1 文字列1
   * @param str2 文字列2
   * @return 同値のときはtrue、そうでないときはfalse **************************************************************************
   */
  public static boolean isEqual(String str1, String str2) {
    if (str1 == null && str2 == null) {
      return true;
    }
    if (str1 != null) {
      return str1.equals(str2);
    } else {
      return false;
    }
  }

}
