# coding: utf-8
"""
CSV一括登録データの列定義、データ型定義
"""
# 　改修（第三者CDI指摘対応）　START
# 一括登録CSV ファイルバイト上限サイズ
UPLOAD_CSV_LIMIT_SIZE = 3670016
# 　改修（第三者CDI指摘対応）　END
# 児童生徒一括登録csv データ上限数
UPLOAD_CSV_INSERT_STUDENT_LIMIT_ROWS = 5000
# 教員一括登録csv データ上限数
UPLOAD_CSV_INSERT_TEACHER_LIMIT_ROWS = 3000
# 学校一括登録csv データ上限数
UPLOAD_CSV_INSERT_SCHOOL_LIMIT_ROWS = 300
# 自動払い出し機能csv データ上限数
UPLOAD_CSV_INSERT_AUTO_GENERATOR_LIMIT_ROWS = 200
# CSVの列情報
column = {
    "teacher11": [
        "organization_code",
        "fiscal_year",
        "role",
        "user_id",
        "persistent_uid",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "title_code",
        "additional_post_code",
        "grade_code",
        "class_code",
        "subject_code",
        "relationgg",
        "relationwin"
    ],
    "teacher12": [
        "organization_code",
        "fiscal_year",
        "role",
        "user_id",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "title_code",
        "additional_post_code",
        "grade_code",
        "class_code",
        "subject_code",
        "relationgg",
        "relationwin"
    ],
    # 　新規追加 START
    "teacher13": [
        "user_id",
        "organization_code"
    ],
    "teacher14": [
        "before_organization_code",
        "organization_code",
        "fiscal_year",
        "role",
        "user_id",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "title_code",
        "additional_post_code",
        "grade_code",
        "class_code",
        "subject_code",
        "relationgg",
        "relationwin"
    ],
    "teacher15": [
        "organization_code",
        "fiscal_year",
        "role",
        "user_id",
        "persistent_uid",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "title_code",
        "additional_post_code",
        "grade_code",
        "class_code",
        "subject_code",
        "relationgg",
        "relationwin"
    ],
    "teacher16": [
        "organization_code",
        "fiscal_year",
        "role",
        "user_id",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "title_code",
        "additional_post_code",
        "grade_code",
        "class_code",
        "subject_code",
        "relationgg",
        "relationwin"
    ],
    # 　新規追加 END
    "student11": [
        "fiscal_year",
        "user_id",
        "persistent_uid",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "grade_code",
        "class_code",
        "student_number",
        "relationgg",
        "relationwin"
    ],
    "student12": [
        "before_user_id",
        "before_grade_code",
        "fiscal_year",
        "user_id",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "grade_code",
        "class_code",
        "student_number",
        "relationgg",
        "relationwin"
    ],
    "student13": [
        "user_id",
        "organization_code",
        "grade_code"
    ],
    "student14": [
        "before_organization_code",
        "before_user_id_transfer",
        "before_grade_code_transfer",
        "organization_code",
        "fiscal_year",
        "user_id",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "grade_code",
        "class_code",
        "student_number",
        "relationgg",
        "relationwin"
    ],
    "school11": [
        # 　新規追加（文科省標準の学校コード追加）　START
        "mextOuCode_prefix",
        "mextOuCode_code",
        # 　新規追加（文科省標準の学校コード追加）　END
        "school_code",
        "school_name",
        "school_name_ja",
        "school_kana",
        "school_nickname",
        "school_type",
        "show_no",
        "district",
        "zip",
        "address1",
        "address2",
        "address1_kana",
        "address2_kana",
        "telnumber",
        "faxnumber",
        "school_mail",
        "school_hp",
        "remarks",
    ],
    "autog11": [
        "no",
        "school_name_ja",
        "school_kana",
        "school_nickname",
        "school_nickname_kana",
        "school_type",
        "show_no",
        # 　新規追加（文科省標準の学校コード追加）　START
        "mextOuCode_prefix",
        "mextOuCode_code",
        # 　新規追加（文科省標準の学校コード追加）　END
        "google_account",
        "teacher_count",
        "class_count",
        "student_count",
        "fiscal_year",
        "exist_school_flg",
    ],
    # 　新規追加
    "user_info_capture": [
        "更新種別",
        "アカウントID",
        "アカウント種別",
        "開始日付",
        "職員コード",
        "氏名（カナ）",
        "性別",
        "生年月日",
        "所属コード",
        "夜間学級区分",
        "職種コード",
        "補職コード",
        "兼務番号",
        "兼務1所属",
        "兼務1職種",
        "兼務1補職",
        "兼務1学校ID",
        "兼務2所属",
        "兼務2職種",
        "兼務2補職",
        "兼務2学校ID",
        "兼務3所属",
        "兼務3職種",
        "兼務3補職",
        "兼務3学校ID",
        "兼務4所属",
        "兼務4職種",
        "兼務4補職",
        "兼務4学校ID",
        "兼務5所属",
        "兼務5職種",
        "兼務5補職",
        "兼務5学校ID",
        "兼務6所属",
        "兼務6職種",
        "兼務6補職",
        "兼務6学校ID",
        "兼務7所属",
        "兼務7職種",
        "兼務7補職",
        "兼務7学校ID",
        "兼務8所属",
        "兼務8職種",
        "兼務8補職",
        "兼務8学校ID",
        "兼務9所属",
        "兼務9職種",
        "兼務9補職",
        "兼務9学校ID",
        "兼務10所属",
        "兼務10職種",
        "兼務10補職",
        "兼務10学校ID",
        "生徒ID（20桁ID）",
        "学校名",
        "学年",
        "組",
        "番号",
        "名前",
        "ふりがな",
        "メールアドレス",
        "学校ID",
        "アカウント有効.無効フラグ",
        "優先権限フラグ",
    ],
}
# CSVのヘッダ情報
header = {
    "teacher11": [
        "学校コード",
        "有効年度",
        "権限",
        "ユーザID",
        "自治体内ユニークID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "職階コード",
        "兼務コード",
        "学年コード",
        "組コード",
        "教科コード",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "teacher12": [
        "学校コード",
        "有効年度",
        "権限",
        "ユーザID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "職階コード",
        "兼務コード",
        "学年コード",
        "組コード",
        "教科コード",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    # 　新規追加 START
    "teacher13": [
        "ユーザID",
        "学校コード"
    ],
    "teacher14": [
        "(異動前)学校コード",
        "学校コード",
        "有効年度",
        "権限",
        "ユーザID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "職階コード",
        "兼務コード",
        "学年コード",
        "組コード",
        "教科コード",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "teacher15": [
        "学校コード",
        "有効年度",
        "権限",
        "ユーザID",
        "自治体内ユニークID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "職階コード",
        "兼務コード",
        "学年コード",
        "組コード",
        "教科コード",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "teacher16": [
        "学校コード",
        "有効年度",
        "権限",
        "ユーザID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "職階コード",
        "兼務コード",
        "学年コード",
        "組コード",
        "教科コード",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    # 　新規追加 END
    "student11": [
        "有効年度",
        "ユーザID",
        "自治体内ユニークID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "学年コード",
        "組コード",
        "出席番号",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "student12": [
        "(進級前)ユーザID",
        "(進級前)学年コード",
        "有効年度",
        "ユーザID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "学年コード",
        "組コード",
        "出席番号",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "student13": [
        "ユーザID",
        "学校コード",
        "学年コード"
    ],
    "student14": [
        "(進学前)学校コード",
        "(進学前)ユーザID",
        "(進学前)学年コード",
        "学校コード",
        "有効年度",
        "ユーザID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "学年コード",
        "組コード",
        "出席番号",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "school11": [
        # 　新規追加（文科省標準の学校コード追加）　START
        "学習eポータル組織コード(接頭子)",
        "学習eポータル組織コード(コード)",
        # 　新規追加（文科省標準の学校コード追加）　END
        "学校コード",
        "学校名(英名)",
        "学校名(日本名)",
        "学校名(カナ)",
        "学校名(略称)",
        "学校タイプ",
        "表示番号",
        "地区",
        "郵便番号",
        "住所１",
        "住所２",
        "住所１(カナ)",
        "住所２(カナ)",
        "電話番号",
        "FAX",
        "メールアドレス",
        "ホームページ",
        "備考",
    ],
    "autog11": [
        "No",
        "学校名(日本語)",
        "学校名(カナ)",
        "学校名(略称)",
        "学校名(略称かな)",
        "学校タイプ",
        "学校の表示番号",
        # 　新規追加（文科省標準の学校コード追加）　START
        "学習eポータル組織コード(接頭子)",
        "学習eポータル組織コード(コード)",
        # 　新規追加（文科省標準の学校コード追加）　END
        "メールのドメイン情報",
        "教員数",
        "組数",
        "1組あたりの児童生徒数",
        "有効年度",
        "既存学校自動払い出しフラグ",
    ],
}
# 数字として扱うルール
numeric_rules = {
	# ↓OneRosterCSV項目取り込みバッチ連携時には以下は必須です
    "admin11": ["relationgg", "relationwin"],
    "admin12": ["relationgg", "relationwin"],
    "admin13": [],
	# ↑ここまで
    "student11": ["class_code", "relationgg", "relationwin", "fiscal_year"],
    "student12": ["class_code", "relationgg", "relationwin", "fiscal_year"],
    "student13": [],
    "student14": ["class_code", "relationgg", "relationwin", "fiscal_year"],
    "teacher11": ["class_code", "relationgg", "relationwin", "fiscal_year"],
    "teacher12": ["class_code", "relationgg", "relationwin", "fiscal_year"],
    # 　新規追加 START
    "teacher13": [],
    "teacher14": ["class_code", "relationgg", "relationwin", "fiscal_year"],
    "teacher15": ["class_code", "relationgg", "relationwin", "fiscal_year"],
    "teacher16": ["class_code", "relationgg", "relationwin", "fiscal_year"],
    # 　新規追加 END
    "school11": ["school_type", "show_no"],
    "autog11": ["school_type", "show_no", "teacher_count", "class_count", "student_count", "fiscal_year", "exist_school_flg"],
}
# 配列として扱うルール
list_splitter = ","
list_rules = {
	# ↓OneRosterCSV項目取り込みバッチ連携時には以下は必須です
    "admin11": [],
    "admin12": [],
    "admin13": ["title_code"],
	# ↑ここまで
    "teacher11": ["title_code", "additional_post_code", "subject_code"],
    "teacher12": ["title_code", "additional_post_code", "subject_code"],
    # 　新規追加 START
    "teacher13": [],
    "teacher14": ["title_code", "additional_post_code", "subject_code"],
    "teacher15": ["title_code", "additional_post_code", "subject_code"],
    "teacher16": ["title_code", "additional_post_code", "subject_code"],
    # 　新規追加 END
    "student11": [],
    "student12": [],
    "student13": [],
    "student14": [],
    "school11": [],
}
