# coding: utf-8
"""
CSV
"""
# CSVの列情報
column = {
    "users_temp": [
    ]
}
# CSVのヘッダ情報
header = {
    "academicSessions": [
        "sourcedId",
        "status",
        "dateLastModified",
        "title",
        "type",
        "startDate",
        "endDate",
        "parentSourcedId",
        "schoolYear"
    ],
    "classes": [
        "sourcedId",
        "status",
        "dateLastModified",
        "title",
        "grades",
        "courseSourcedId",
        "classCode",
        "classType",
        "location",
        "schoolSourcedId",
        "termSourcedIds",
        "subjects",
        "subjectCodes",
        "periods",
        "metadata.jp.specialNeeds"
    ],
    "demographics": [
        "sourcedId",
        "status",
        "dateLastModified",
        "birthDate",
        "sex",
        "americanIndianOrAlaskaNative",
        "asian",
        "blackOrAfricanAmerican",
        "nativeHawaiianOrOtherPacificIslander",
        "white",
        "demographicRaceTwoOrMoreRaces",
        "hispanicOrLatinoEthnicity",
        "countryOfBirthCode",
        "stateOfBirthAbbreviation",
        "cityOfBirth",
        "publicSchoolResidenceStatus"
    ],
    "enrollments": [
        "sourcedId",
        "status",
        "dateLastModified",
        "classSourcedId",
        "schoolSourcedId",
        "userSourcedId",
        "role",
        "primary",
        "beginDate",
        "endDate",
        "metadata.jp.ShussekiNo",
        "metadata.jp.PublicFlg"
    ],
    "orgs": [
        "sourcedId",
        "status",
        "dateLastModified",
        "name",
        "type",
        "identifier",
        "parentSourcedId"
    ],
    "users": [
        "sourcedId",
        "status",
        "dateLastModified",
        "enabledUser",
        "username",
        "userIds",
        "givenName",
        "familyName",
        "middleName",
        "identifier",
        "email",
        "sms",
        "phone",
        "agentSourcedIds",
        "grades",
        "password",
        "userMasterIdentifier",
        "resourceSourcedIds",
        "preferredGivenName",
        "preferredMiddleName",
        "preferredFamilyName",
        "primaryOrgSourcedId",
        "pronouns",
        "metadata.jp.kanaGivenName",
        "metadata.jp.kanaFamilyName",
        "metadata.jp.kanaMiddleName",
        "metadata.jp.homeClass"
    ],
    "roles": [
        "sourcedId",
        "status",
        "dateLastModified",
        "userSourcedId",
        "roleType",
        "role",
        "beginDate",
        "endDate",
        "orgSourcedId",
        "userProfileSourcedId"
    ],
    "manifest": [
        "propertyName",
        "value"
    ]
}

TEMP_FILE_COLUMN = [
    "sourcedId",
    "status",
    "givenName",
    "familyName",
    "email",
    "grades",
    "password",
    "username",
    "userMasterIdentifier",
    "kanaGivenName",
    "kanaFamilyName",
    "schoolCode",
    "schoolYear",
    "role",
    "shussekiNo",
    "classCode",
    "subjectCodes",
    "sex"
]

ERROR_FILE_COLUMN = [
    "userMasterIdentifier",
    "detail"
]

# manifest
CSV_FILE_NAME_MANIFEST = "manifest.csv"
# academicSessions
CSV_FILE_NAME_ACADEMIC_SESSIONS = "academicSessions.csv"
# Demographics
CSV_FILE_NAME_DEMOGRAPHICS = "demographics.csv"
# Enrollments
CSV_FILE_NAME_ENROLLMENTS = "enrollments.csv"
# Classes
CSV_FILE_NAME_CLASSES = "classes.csv"
# Orgs
CSV_FILE_NAME_ORGS = "orgs.csv"
# Roles
CSV_FILE_NAME_ROLES = "roles.csv"
# Users
CSV_FILE_NAME_USERS = "users.csv"

user_search = [
    "persistent_uid",
    "user_id",
    "grade_code",
    "organization_code",
    "relationgg",
    "relationwin",
    "upd_date",
    "title_code",
    "additional_post_code",
    "organization_name",
    "sur_name_kana",
    "given_name_kana",
    "subject_code",
    "class_code",
    "gender",
    "mail",
    "student_number",
    "mextUid",
    "role"
]

ldap_search = [
    "user_id",
    "opaque_id",
    "persistent_uid",
    "organization_name",
    "organization_name_ja",
    "organization_code",
    "organization_type",
    "given_name",
    "given_name_kana",
    "sur_name",
    "sur_name_kana",
    "gender",
    "fiscal_year",
    "person_affiliation_code",
    "role",
    "system_organization_type",
    "system_organization_name",
    "system_organization_name_ja",
    "system_organization_code",
    "title_code",
    "additional_post_code",
    "subject_code",
    "grade_code",
    "grade_name",
    "class_code",
    "class_name",
    "student_number",
    "mail",
    "relationgg",
    "relationwin",
    "reg_date",
    "from_organization_code",
    "transfer_school_date",
    "mextUid",
    "mextOuCode",
]

# 一括受付のCSVのコラム情報
bulk_column = {
    "teacher11": [
        "organization_code",
        "fiscal_year",
        "role",
        "user_id",
        "persistent_uid",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "title_code",
        "additional_post_code",
        "grade_code",
        "class_code",
        "subject_code",
        "relationgg",
        "relationwin",
        "mextUid"
    ],
    "teacher12": [
        "organization_code",
        "fiscal_year",
        "role",
        "user_id",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "title_code",
        "additional_post_code",
        "grade_code",
        "class_code",
        "subject_code",
        "relationgg",
        "relationwin"
    ],
    "teacher13": [
        "user_id",
        "organization_code"
    ],
    "teacher14": [
        "before_organization_code",
        "organization_code",
        "fiscal_year",
        "role",
        "user_id",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "title_code",
        "additional_post_code",
        "grade_code",
        "class_code",
        "subject_code",
        "relationgg",
        "relationwin"
    ],
    "student11": [
        "fiscal_year",
        "user_id",
        "persistent_uid",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "grade_code",
        "class_code",
        "student_number",
        "relationgg",
        "relationwin",
        "mextUid"
    ],
    "student12": [
        "before_user_id",
        "before_grade_code",
        "fiscal_year",
        "user_id",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "grade_code",
        "class_code",
        "student_number",
        "relationgg",
        "relationwin"
    ],
    "student13": [
        "user_id",
        "organization_code",
        "grade_code"
    ],
    "student14": [
        "before_organization_code",
        "before_user_id_transfer",
        "before_grade_code_transfer",
        "organization_code",
        "fiscal_year",
        "user_id",
        "sur_name",
        "given_name",
        "sur_name_kana",
        "given_name_kana",
        "password",
        "gender",
        "mail",
        "grade_code",
        "class_code",
        "student_number",
        "relationgg",
        "relationwin"
    ],
    "admin11": [
        "organization_code",
        "role",
        "user_id",
        "persistent_uid",
        "sur_name",
        "given_name",
        "password",
        "gender",
        "mail",
        "title_code",
        "relationgg",
        "relationwin",
        "mextUid"
    ],
    "admin12": [
        "organization_code",
        "role",
        "user_id",
        "sur_name",
        "given_name",
        "password",
        "gender",
        "mail",
        "relationgg",
        "relationwin"
    ],
    "admin13": [
        "user_id",
        "organization_code"
    ],
}
# 一括受付のCSVのヘッダ情報
bulk_header = {
    "teacher11": [
        "学校コード",
        "有効年度",
        "権限",
        "ユーザID",
        "自治体内ユニークID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "職階コード",
        "兼務コード",
        "学年コード",
        "組コード",
        "教科コード",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
        "mextUid"
    ],
    "teacher12": [
        "学校コード",
        "有効年度",
        "権限",
        "ユーザID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "職階コード",
        "兼務コード",
        "学年コード",
        "組コード",
        "教科コード",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "teacher13": [
        "ユーザID",
        "学校コード"
    ],
    "teacher14": [
        "(異動前)学校コード",
        "学校コード",
        "有効年度",
        "権限",
        "ユーザID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "職階コード",
        "兼務コード",
        "学年コード",
        "組コード",
        "教科コード",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "student11": [
        "有効年度",
        "ユーザID",
        "自治体内ユニークID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "学年コード",
        "組コード",
        "出席番号",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
        "mextUid",
    ],
    "student12": [
        "(進級前)ユーザID",
        "(進級前)学年コード",
        "有効年度",
        "ユーザID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "学年コード",
        "組コード",
        "出席番号",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "student13": [
        "ユーザID",
        "学校コード",
        "学年コード"
    ],
    "student14": [
        "(進学前)学校コード",
        "(進学前)ユーザID",
        "(進学前)学年コード",
        "学校コード",
        "有効年度",
        "ユーザID",
        "姓",
        "名",
        "姓(ふりがな)",
        "名(ふりがな)",
        "パスワード",
        "性別",
        "メールアドレス",
        "学年コード",
        "組コード",
        "出席番号",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "admin11": [
        "学校コード",
        "権限",
        "ユーザID",
        "自治体内ユニークID",
        "姓",
        "名",
        "パスワード",
        "性別",
        "メールアドレス",
        "職階コード",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
        "mextUid",
    ],
    "admin12": [
        "学校コード",
        "権限",
        "ユーザID",
        "姓",
        "名",
        "パスワード",
        "性別",
        "メールアドレス",
        "Googleアカウント作成有無",
        "AzureADアカウント作成有無",
    ],
    "admin13": [
        "ユーザID",
        "学校コード"
    ],
}
